Subject: bug#47432: 28.0.50; Dired using ! or & on file should fail without command supplied

From: Jean Louis <[email-masked]>
Date: Sat, 27 Mar 2021 21:54:16 +0300

* Arthur Miller <[email-masked]> [2021-03-27 17:00]:
> How you seen the docs? For example C-h k ! RET:
> 
> Signature
> (dired-do-shell-command COMMAND &optional ARG FILE-LIST)
> 
> Documentation
> Run a shell command COMMAND on the marked files.
> 
> 
> > Why should there be attempt to execute non-executable files?
> 
> Because you asked it to by calling ! or & on a file in Dired.

I have got a feeling you have not get really what is taking place:

1. Dired mode
2. Come on any file or directory, not executable
3. Press ! or &
4. Press ENTER
5. Get error, it can be different, depending of situation. Like
   /usr/bin/bash: line 1: admin_Leo: command not found where "admin_Leo"
    is directory

I cannot see in the documentation that ! or & in Dired is supposed to
run that specific marked file as COMMAND. I can understand that
command is asked and user should enter the command. But I do not see
that the marked file is supposed to be executed as COMMAND when
command is not manually entered by user.

Why is Emacs trying to execute a directory?

Why is Emacs trying to execute non-executable file?

- documentation of the function should maybe reflect that ! or & is
  meant to execute the marked file or current file in Dired if no
  COMMAND is supplied manually.

- Emacs should stop trying to execute directories or non executable
  files.